﻿using System;
using System.Collections;
using UnityEngine;

namespace Mod
{
    class GoldPoison : TemporaryBodyLiquid
    {
        public override void OnEnterLimb(LimbBehaviour limb)
        {
            limb.gameObject.AddComponent<GoldPoisonBehaviour>();
        }

        public const string ID = "Gold";

        public override void OnEnterContainer(BloodContainer container)
        {
            container.gameObject.AddComponent<GoldPoisonBehaviour>();
        }

        public override void OnExitContainer(BloodContainer container)
        {
        
        }


        public GoldPoison()
        {
        }
    }



    class GoldPoisonBehaviour : MonoBehaviour
    {
        LimbBehaviour Limb;

        void Awake()
        {
 
            this.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 0.9f, 0f, 1f);
            this.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            Limb = gameObject.GetComponent<LimbBehaviour>();
            Limb.Frozen = true;
        }

        void OnCollisionEnter2D(Collision2D other)
        {
            if(other.gameObject.GetComponent<ImmortalityBehaviour>() == null & other.gameObject.GetComponent<GoldPoisonBehaviour>() == null)
            {

                if(other.gameObject.TryGetComponent(out LimbBehaviour l))
                {
                    l.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("GoldInfection"), 1.4f);
                }


            }

        }
        private void Nullificator()
        {
            Destroy(this);
        }
    }
}
