﻿using UnityEngine;
using UnityEngine.Events;
using TMPro;
using System.Linq;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static void Main()
        {
            CategoryBuilder.Create("HT", "", ModAPI.LoadSprite("textures/InGameIcon.png"));




            Liquid.Register("GoldInfection",new GoldPoison());
            Liquid.Register("???", new hellP());
            Liquid.Register("????", new VampireP());




            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Slightly Improved Human " + " +HT",
        NameToOrderByOverride = "A1",
        DescriptionOverride = "A little stronger than the average human." + "\n <color=orange>[Tier 1] ",
        CategoryOverride = ModAPI.FindCategory("HT"),
        ThumbnailOverride = ModAPI.LoadSprite("textures/human1.png"),
        AfterSpawn = (Instance) =>
        {
            var person = Instance.GetComponent<PersonBehaviour>();



            foreach (var body in person.Limbs)
            {
                body.BaseStrength += 2f;
                body.Health *= 1.5f;
                body.InitialHealth *= 1.5f;
                body.ShotDamageMultiplier *= 0.5f;
                body.BreakingThreshold += 10f;
                body.RegenerationSpeed += 5f;
                body.Vitality *= 1.5f;
                body.ImpactPainMultiplier *= 0.5f;
                body.Numbness *= 1.2f;
            }



        }
    }







            );

            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Experimental Model" + " +HT",
NameToOrderByOverride = "A2",
DescriptionOverride = "Bites and infects others" + "\n <color=orange>[Tier 1] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/bit.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();
    var head = Instance.transform.Find("Head");
    head.gameObject.AddComponent<bite>();



    foreach (var body in person.Limbs)
    {

        body.Health *= 2.6f;
        body.InitialHealth *= 2.6f;

        body.RegenerationSpeed += 10f;

        body.IsZombie = true;


    }
    var skin = ModAPI.LoadTexture("textures/biter.png");
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
}
}


);








            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Improved Human" + " +HT",
    NameToOrderByOverride = "A2",
    DescriptionOverride = "Stronger than the average human." + "\n <color=orange>[Tier 2] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/human2.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

    foreach (var body in person.Limbs)
{
    body.BaseStrength += 4f;
    body.Health *= 2.6f;
    body.InitialHealth *= 2.6f;
    body.ShotDamageMultiplier *= 0.2f;
    body.BreakingThreshold += 10f;
    body.RegenerationSpeed += 10f;
    body.Vitality *= 3f;
    body.ImpactPainMultiplier *= 0.2f;
    body.Numbness *= 3f;
        body.CirculationBehaviour.BloodFlow *= 4f;
        body.IsLethalToBreak = false;
    }


}
}
);




            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "A Highly Improved Human" + " +HT",
    NameToOrderByOverride = "A3",
    DescriptionOverride = "Much stronger than the average human. Has a limited and weak ability to regenerate. Regeneration disappears if you deals damage long enough" + "\n <color=orange>[Tier 3] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/human3.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();
   // arm1.gameObject.AddComponent<EnergySwordBehaviour>().BladeObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/bowgun.png");

    foreach (var body in person.Limbs)
{
body.BaseStrength += 3f;
body.Health *= 7.6f;
body.InitialHealth *= 7.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
        body.gameObject.AddComponent<NoSleep>();
}


}
}
);













            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "A Human with implant" + " +HT",
NameToOrderByOverride = "A3",
DescriptionOverride = "Much stronger than the average human. Can't bleed and doesn't feel pain" + "\n <color=orange>[Tier 3] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/chip.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();


foreach (var body in person.Limbs)
{
body.BaseStrength += 3f;
body.Health *= 7.6f;
body.InitialHealth *= 7.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
body.gameObject.AddComponent<HeroNoSleep>();
}
    var skin = ModAPI.LoadTexture("textures/skinhuman2.png");
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Regenerator" + " +HT",
    NameToOrderByOverride = "A4",
    DescriptionOverride = "This human is stronger than the average person and have strong regenerative abilities." + "\n <color=orange>[Tier 4] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/human4.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 2.6f;
body.InitialHealth *= 2.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0.2f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
        body.gameObject.AddComponent<NoSleep7>();
       // body.gameObject.GetComponent<NoSleep7>().time = 2f;

    }


}
}
);

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀",
                    DescriptionOverride = "Piece of Somebody.\nWhat was it before? \nA hero, a god, or a creature created by someone who hates humanity?" + "\n <color=#ffC0cb>[Tier ???]",
                    CategoryOverride = ModAPI.FindCategory("HT"),
                    ThumbnailOverride = ModAPI.LoadSprite("textures/human4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        
                        //parts
                        var armLeft = Instance.transform.Find("FrontArm");
                        var armRight = Instance.transform.Find("BackArm");
                        var legLeft = Instance.transform.Find("FrontLeg");
                        var legRight = Instance.transform.Find("BackLeg");
                        var head = Instance.transform.Find("Head");
                        var Body= Instance.transform.Find("Body");




                        //woot
                        Body.localScale = new Vector3(1.35f, 1f, 1f);
                        Body.Find("LowerBody").localPosition = new Vector3(0f, -0.035f, 0f);

                        head.localPosition = new Vector3(0f, 0.8f, 0f);

                        armLeft.localPosition = new Vector3(-0.2f, 0.475f, 0f);
                        armLeft.localRotation = Quaternion.Euler(0f, 0f, -90f);
                        armRight.localPosition = new Vector3(0.2f, 0.475f, 0f);

                        armRight.localRotation = Quaternion.Euler(0f, 0f, 90f);

                        armLeft.Find("UpperArmFront").localScale = new Vector3(1.1f, 1f, 1f);
                        armRight.Find("UpperArm").localScale = new Vector3(1.1f, 1f, 1f);

                        legLeft.localPosition = new Vector3(-0.1f, 0.045f, 0f);
                        legLeft.localScale = new Vector3(1.2f, 1f, 1f);
                        legRight.localPosition = new Vector3(0.1f, 0.045f, 0f);
                        legRight.localScale = new Vector3(1.2f, 1f, 1f);

                        legLeft.Find("LowerLegFront").localPosition = new Vector3(0.015f, -0.85f, 0f);
                        legLeft.Find("LowerLegFront").localScale = new Vector3(0.80f, 1.2f, 1f);
                        legRight.Find("LowerLeg").localPosition = new Vector3(-0.015f, -0.85f, 0f);
                        legRight.Find("LowerLeg").localScale = new Vector3(0.80f, 1.2f, 1f);


                      


                        foreach (var body in person.Limbs)
                        {
                            body.PhysicalBehaviour.rigidbody.gravityScale *= 0.2f;
                            body.PhysicalBehaviour.rigidbody.mass *= 2f;
                            body.IsLethalToBreak = false;


                        }
                    }
                }
            );



            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Acid Human" + " +HT",
                DescriptionOverride = "Disintegrates flesh on touch." + "\n <color=orange>[Tier 4] ",
                NameToOrderByOverride = "A4",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/acid.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    arm1.gameObject.AddComponent<killbeh>();
                    arm2.gameObject.AddComponent<killbeh>();
                    foreach (var body in person.Limbs)
                    {
                        body.BaseStrength += 2f;
                        body.Health *= 2.6f;
                        body.InitialHealth *= 2.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;
                        body.gameObject.AddComponent<NoSleep7>().spec = false;
                    }


                }
            }
            );


            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "The Tester" + " +HT",
NameToOrderByOverride = "A4",
DescriptionOverride = "Activate head to swap positions with the person it is looking at \n<b><i> We must continue the experiments, it's the only way we can get revenge on them and prove that you are truly the enemy of humanity.</b></i>" + "\n <color=orange>[Tier 4] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/hh.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();
    var head = Instance.transform.Find("Head");
    head.gameObject.AddComponent<SwitchPlaces>();

    foreach (var body in person.Limbs)
{
body.BaseStrength += 2f;
body.Health *= 7.6f;
body.InitialHealth *= 7.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 2f;
body.ImpactPainMultiplier *= 0f;
body.Numbness *= 2f;
body.CirculationBehaviour.BloodFlow *= 2f;
body.IsLethalToBreak = false;
body.gameObject.AddComponent<HeroNoSleep>();
}
var skin = ModAPI.LoadTexture("textures/headhunter.png");
Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
}
}
);

            //            ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Human"),
            //    NameOverride = "???" + " +HT",
            //    DescriptionOverride = "." + "\n <color=orange>[Tier 4] ",
            //    NameToOrderByOverride = "A4",
            //    CategoryOverride = ModAPI.FindCategory("HT"),
            //    ThumbnailOverride = ModAPI.LoadSprite("textures/acid.png"),

            //    AfterSpawn = (Instance) =>
            //    {
            //        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
            //        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
            //        var head = Instance.transform.Find("Head");


            //        var upper = Instance.transform.Find("Body").Find("UpperBody");
            //        arm1.GetComponent<LimbBehaviour>().ImmuneToDamage = true;
            //        arm2.GetComponent<LimbBehaviour>().ImmuneToDamage = true;
            //        head.GetComponent<LimbBehaviour>().ImmuneToDamage = true;
            //        upper.GetComponent<LimbBehaviour>().ImmuneToDamage = true;

            //        head.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            //        upper.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            //        arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            //        arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");


            //        var person = Instance.GetComponent<PersonBehaviour>();

            //        foreach (var body in person.Limbs)
            //        {
            //            body.BaseStrength += 2f;
            //            body.Health *= 2.6f;
            //            body.InitialHealth *= 2.6f;
            //            body.ShotDamageMultiplier *= 0.2f;
            //            body.BreakingThreshold += 10f;
            //            body.RegenerationSpeed += 10f;
            //            body.Vitality *= 3f;
            //            body.ImpactPainMultiplier *= 0.2f;
            //            body.Numbness *= 3f;
            //            body.CirculationBehaviour.BloodFlow *= 4f;
            //            body.IsLethalToBreak = false;
            //            body.gameObject.AddComponent<NoSleep3>();
            //        }


            //    }
            //}
            //);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Midas" + " +HT",
    DescriptionOverride = "Turns flesh into a gold.." + "\n <color=orange>[Tier 4] ",
    NameToOrderByOverride = "A4",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/midas.png"),

    AfterSpawn = (Instance) =>
    {
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
        var head = Instance.transform.Find("Head");

        GameObject crown = new GameObject();
        crown.transform.parent = head;
        crown.transform.localPosition = new Vector3(0f, 0.3f);
        crown.transform.localScale = new Vector3(0.3f, 0.3f);

        var crownSprite = crown.AddComponent<SpriteRenderer>();

        crownSprite.sprite = ModAPI.LoadSprite("textures/crown.png");
        crownSprite.material = ModAPI.FindMaterial("VeryBright");
        crownSprite.color = new Color(1f, 1f, 0f, 0.25f);
        crownSprite.sortingLayerName = "Top";


        var person = Instance.GetComponent<PersonBehaviour>();
        arm1.gameObject.AddComponent<killbeh2>();
        arm2.gameObject.AddComponent<killbeh2>();
        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 2f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.gameObject.AddComponent<NoSleep7>().spec = true;
        }


    }
}
);
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Crusher" + " +HT",
                NameToOrderByOverride = "A5",
                DescriptionOverride = "Rip & Tear." + "\n <color=orange>[Tier 5] ",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/crusher.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                    var head = Instance.transform.Find("Head");
                    GameObject alsoEye = new GameObject();
                    alsoEye.transform.parent = head;
                    alsoEye.transform.localPosition = new Vector3(0f, 0f);
                    alsoEye.transform.localScale = new Vector3(1f, 1f);

                    var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

                    eyeSprite.sprite = ModAPI.LoadSprite("textures/Glaz.png");
                    eyeSprite.material = ModAPI.FindMaterial("VeryBright");
                    eyeSprite.color = new Color(0.5f, 0.2f, 0.8f, 0.65f);
                    eyeSprite.sortingLayerName = "Top";
                    var person = Instance.GetComponent<PersonBehaviour>();
                    arm1.gameObject.AddComponent<killbeh4>();
                    arm2.gameObject.AddComponent<killbeh4>();
                    foreach (var body in person.Limbs)
                    {
                        body.BaseStrength += 2f;
                        body.Health *= 4.6f;
                        body.InitialHealth *= 4.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;
                        body.gameObject.AddComponent<NoSleep7>().spec = true;
                    }


                }
            }
            );

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Rotten God " + " +HT",
    NameToOrderByOverride = "A6",
    DescriptionOverride = "Disintegrates flesh nearbly." + "\n <color=red>[Tier 6] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/roten.png"),

    AfterSpawn = (Instance) =>
    {

        var head = Instance.transform.Find("Head");

        head.gameObject.AddComponent<Aura1>();

        var person = Instance.GetComponent<PersonBehaviour>();

       





        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 2f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

            body.gameObject.AddComponent<NoSleep7>();
            body.gameObject.GetComponent<NoSleep7>().power = 1;


        }
        var skin = ModAPI.LoadTexture("textures/skin.png");
        var ske = ModAPI.LoadTexture("textures/skeleton2.png");


        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, ske);
        person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(10, 10, 10); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(10, 10, 10);
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Absorber" + " +HT",
    NameToOrderByOverride = "A5",
    DescriptionOverride = "Can absorb other humans to become stronger." + "\n <color=orange>[Tier 5] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/absorb.png"),

    AfterSpawn = (Instance) =>
    {

        var person = Instance.GetComponent<PersonBehaviour>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 2f;
            body.Health *= 4.6f;
            body.InitialHealth *= 4.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.gameObject.AddComponent<NoSleep4>();
            
        }
        var skin = ModAPI.LoadTexture("textures/skin1.png");
        var none = ModAPI.LoadTexture("textures/none.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

    }
}
);











            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Nullificator" + " +HT",
                NameToOrderByOverride = "A5",
                DescriptionOverride = "Can nullify most of the powers" + "\n <color=orange>[Tier 5] ",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/nullif.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var person = Instance.GetComponent<PersonBehaviour>();

                    arm1.gameObject.AddComponent<Aura2>();
                    foreach (var body in person.Limbs)
                    {
                        body.BaseStrength += 2f;
                        body.Health *= 2.6f;
                        body.InitialHealth *= 2.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;
                        body.gameObject.AddComponent<NoSleep7>().spec = true;
                    }


                }
            }
            );

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Replicator X1-5" + " +HT",
    DescriptionOverride = "Infects other humans on touch." + "\n <color=orange>[Tier 2] ",
    NameToOrderByOverride = "A2",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/replic.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 4f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.IsZombie = true;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            
        }
        arm1.gameObject.AddComponent<Aura3>();

    }
}
);

            ModAPI.Register(
 new Modification()
 {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = "The Great Champion" + " +HT",
     NameToOrderByOverride = "A6",
     DescriptionOverride = "Infinity punch power.Living matter disappear without a trace in a couple of seconds after being hit" + "\n <color=red>[Tier 6] ",
     CategoryOverride = ModAPI.FindCategory("HT"),
     ThumbnailOverride = ModAPI.LoadSprite("textures/champ.png"),

     AfterSpawn = (Instance) =>
     {
         var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
         var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
         var head = Instance.transform.Find("Head");
         GameObject alsoEye = new GameObject();
         alsoEye.transform.parent = head;
         alsoEye.transform.localPosition = new Vector3(0f, 0f);
         alsoEye.transform.localScale = new Vector3(1f, 1f);

         var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

         eyeSprite.sprite = ModAPI.LoadSprite("textures/Glaz2.png");
         eyeSprite.material = ModAPI.FindMaterial("VeryBright");
         eyeSprite.color = new Color(0.8f, 0.8f, 0.8f, 0.1f);
         eyeSprite.sortingLayerName = "Top";
         var person = Instance.GetComponent<PersonBehaviour>();
         arm1.gameObject.AddComponent<killbeh5>();
         arm2.gameObject.AddComponent<killbeh5>();
         foreach (var body in person.Limbs)
         {
             body.BaseStrength += 2f;
             body.Health *= 1000f;
             body.InitialHealth *= 1000f;
             body.ShotDamageMultiplier *= -2f;
             body.BreakingThreshold *= 1000f;
             body.RegenerationSpeed += 1000f;
             body.Vitality *= 1000f;
             body.ImpactPainMultiplier *= 0f;
             body.Numbness *= 3f;
             body.CirculationBehaviour.BloodFlow *= 1000f;
             body.IsLethalToBreak = false;
             body.gameObject.AddComponent<NoSleep7>();

             
         }


     }
 }
 );
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Giant human +HT",
        DescriptionOverride = "<color=orange>[Tier 2]",
        NameToOrderByOverride = "A2",
        CategoryOverride = ModAPI.FindCategory("HT"),
        ThumbnailOverride = ModAPI.LoadSprite("textures/6621.png"),
        AfterSpawn = (Instance) =>
        {
            var person = Instance.GetComponent<PersonBehaviour>();

            var skin = ModAPI.LoadTexture("textures/bigSkin.png");
            person.SetBodyTextures(skin, null, null);

            foreach (var body in person.Limbs)
            {
                body.transform.root.localScale *= 1.03f;
                body.Health *= 40f;
                body.BaseStrength *= 6.5f;
                body.BreakingThreshold *= 55f;
                body.gameObject.AddComponent<NoSleep7>().spec = true;
            }
        }
    }
);

            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Star Glitcher" + " +HT",
    NameToOrderByOverride = "A7",
    DescriptionOverride = "Strong gravitational anomaly surrounds his body. \n <b><i>The last scholar of <color=#ffC0cb>Z'othra</color>.</i></b>" + "\n <color=purple>[Tier 7] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/star.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();


    var head = Instance.transform.Find("Head");

    head.gameObject.AddComponent<Aura4>();


    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 2.6f;
body.InitialHealth *= 2.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 3f;
body.IsZombie = true;
body.ImpactPainMultiplier *= 0.2f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 2f;
body.IsLethalToBreak = false;
        body.PhysicalBehaviour.MakeWeightless();
        body.transform.root.localScale *= 1.04f;
        body.gameObject.AddComponent<NoSleep7>();
        body.gameObject.GetComponent<NoSleep7>().power = 3;
        body.ExplodeLiquidAmount *= 200f;
    }
    var skin = ModAPI.LoadTexture("textures/forgottenone.png");
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

}
}
);


            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Enemy of Humanity" + " +HT",
    NameToOrderByOverride = "A7",
    DescriptionOverride = "Can absorb some people with powers to gain their powers. \n Right click on the hand to change the current ability" + "\n <color=purple>[Tier 7] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/absorb2.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();


    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    arm1.gameObject.AddComponent<killbeh6>();

    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 2.6f;
body.InitialHealth *= 2.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0.2f;
body.Numbness *= 3f;
        
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
        body.gameObject.AddComponent<NoSleep7>();
body.gameObject.GetComponent<NoSleep7>().power = 2;
}
    var skin = ModAPI.LoadTexture("textures/enemy.png");
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

}
}
);


            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Healer" + " +HT",
    NameToOrderByOverride = "A4",
    DescriptionOverride = "Heals nearby humans" + "\n <color=orange>[Tier 4] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/heal1.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();
    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
    arm1.gameObject.AddComponent<Heal>();
    arm2.gameObject.AddComponent<Heal>();
    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 2.6f;
body.InitialHealth *= 2.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0.2f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
        body.gameObject.AddComponent<HealBeh>();

    }


}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Toge" + " +HT",
    NameToOrderByOverride = "A3",
    DescriptionOverride = "They used to be people too." + "\n <color=orange>[Tier 3] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/toge.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");


    //var component = arm1.GetComponent<PhysicalBehaviour>();
    //var chelovek = ModAPI.FindPhysicalProperties("Human");
    //chelovek.Sharp = true;
    //chelovek.SharpAxes = new[]
    //{
    //                        new SharpAxis(Vector2.down, 0f, 0.55f, false, true),
    //                    };
    //component.Properties = chelovek;
    //var component2 = arm2.GetComponent<PhysicalBehaviour>();
    //component2.Properties = chelovek;
    arm1.gameObject.AddComponent<Spike>();
    arm2.gameObject.AddComponent<Spike>();

    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 1.6f;
body.InitialHealth *= 1.6f;
body.ShotDamageMultiplier *= 0.6f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 4f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0.2f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
        body.gameObject.AddComponent<NoSleep7>().spec = true;

    }

    var skin = ModAPI.LoadTexture("textures/spiker.png");
    var flesh = ModAPI.LoadTexture("textures/fleshlayer2.png");
    var bone = ModAPI.LoadTexture("textures/bonelayer1.png");
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "E.M.P. Operative" + " +HT",
    NameToOrderByOverride = "A3",
    DescriptionOverride = "Damages electronics around himself " + "\n <color=orange>[Tier 3] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/emp.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();
    var upper = Instance.transform.Find("Body").Find("UpperBody");

    upper.gameObject.AddComponent<EmpAgent>();


    GameObject backpacks = new GameObject();
    backpacks.transform.parent = upper;
    backpacks.transform.localPosition = new Vector2(-0.25f, 0f);
    backpacks.transform.localScale = new Vector2(1.5f, 1.5f);

    var backpacksprite = backpacks.AddComponent<SpriteRenderer>();

    backpacksprite.sprite = ModAPI.LoadSprite("textures/backpack.png");
  

    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 1.6f;
body.InitialHealth *= 1.6f;
body.BreakingThreshold += 10f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0.2f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 2f;

}


}
}
); 
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Flame human" + " +HT",
DescriptionOverride = "Flame punch!" + "\n <color=orange>[Tier 4] ",
CategoryOverride = ModAPI.FindCategory("HT"),
    NameToOrderByOverride = "A4",
    ThumbnailOverride = ModAPI.LoadSprite("textures/flame.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

    arm1.gameObject.AddComponent<Firebeh>();
    arm2.gameObject.AddComponent<Firebeh>();

    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 1.6f;
body.InitialHealth *= 1.6f;
body.ShotDamageMultiplier *= 0.6f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 4f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0.2f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
body.gameObject.AddComponent<nofire>();
       // body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
        body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Flammability = 0f;
        body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Burnrate = 0f;
        body.DiscomfortingHeatTemperature += 2000f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
        body.PhysicalBehaviour.burnIntensity = 0f;

    }


}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Leidrigo" + " +HT",
DescriptionOverride = "Electric punch!" + "\n <color=orange>[Tier 5] ",
CategoryOverride = ModAPI.FindCategory("HT"),
NameToOrderByOverride = "A5",
ThumbnailOverride = ModAPI.LoadSprite("textures/elec.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

    var head = Instance.transform.Find("Head");

    head.gameObject.AddComponent<elecshoot>();
    arm1.gameObject.AddComponent<Electro>();
arm2.gameObject.AddComponent<Electro>();


foreach (var body in person.Limbs)
{
   body.BaseStrength += 4f;
   body.Health *= 1.6f;
   body.InitialHealth *= 1.6f;
   body.ShotDamageMultiplier *= 0.6f;
   body.BreakingThreshold += 10f;
   body.RegenerationSpeed += 4f;
   body.Vitality *= 3f;
   body.ImpactPainMultiplier *= 0.2f;
   body.Numbness *= 3f;
   body.CirculationBehaviour.BloodFlow *= 4f;
   body.IsLethalToBreak = false;
  // body.gameObject.AddComponent<nofire>();
           

        body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Conducting = false;


}


}
}
);




            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Duality Elemental" + " +HT",
    NameToOrderByOverride = "A5",
    DescriptionOverride = "One hand kills everything that it touches, the other one heals" + "\n <color=orange>[Tier 5] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/duality.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

arm1.gameObject.AddComponent<dualkill>();
arm2.gameObject.AddComponent<dualheal>();

foreach (var body in person.Limbs)
{
        body.BaseStrength += 2f;
        body.Health *= 2.6f;
        body.InitialHealth *= 2.6f;
        body.ShotDamageMultiplier *= 0.2f;
        body.BreakingThreshold += 10f;
        body.RegenerationSpeed += 10f;
        body.Vitality *= 3f;
        body.ImpactPainMultiplier *= 0.4f;
        body.Numbness *= 3f;
        body.CirculationBehaviour.BloodFlow *= 4f;
        body.IsLethalToBreak = false;
        body.gameObject.AddComponent<NoSleep7>().spec = true;

    }
    var skin = ModAPI.LoadTexture("textures/dual.png");
    var flesh = ModAPI.LoadTexture("textures/dualflesh.png");
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, null);

}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Dwade The Fallen" + " +HT",
    NameToOrderByOverride = "A8",
    DescriptionOverride = "Activate head to release a powerful gravitational pulse over all the lab \n <b><i>The voice of the long dead <color=#ffC0cb>Z'othra</color> still resounds in his head.</b></i> " + "\n <color=green>[Tier 8] ",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/Dwade.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

    var head = Instance.transform.Find("Head");


    head.gameObject.AddComponent<UltimateBeing>();
    GameObject alsoEye = new GameObject();
    alsoEye.transform.parent = head;
    alsoEye.transform.localPosition = new Vector3(0f, 0f);
    alsoEye.transform.localScale = new Vector3(1f, 1f);

    var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

    eyeSprite.sprite = ModAPI.LoadSprite("textures/sym.png");
    eyeSprite.material = ModAPI.FindMaterial("VeryBright");
    eyeSprite.color = new Color(1f, 0f, 0f, 0.1f);
    eyeSprite.sortingLayerName = "Top";

    foreach (var body in person.Limbs)
{
body.BaseStrength += 4f;
body.Health *= 8548f;
body.InitialHealth *= 8548f;
body.ShotDamageMultiplier *= 0f;
body.BreakingThreshold *= 99999;
body.RegenerationSpeed += 4f;
body.Vitality *= 3f;
body.ImpactPainMultiplier *= 0f;
body.Numbness *= 3f;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
        body.BloodDecal = null;
body.gameObject.AddComponent<ImmortalityBehaviour>();
        body.PhysicalBehaviour.ReflectsLasers = true;
        //body.transform.gameObject.SetLayer(10, true);
        body.ExplodeLiquidAmount *= 200f;

    }

    var skin = ModAPI.LoadTexture("textures/soulEater.png");
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
}
}
);


            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Stasis human" + " +HT",
                DescriptionOverride = "Stops moving objects" + "\n <color=orange>[Tier 4] ",
                NameToOrderByOverride = "A4",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/static.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                    var person = Instance.GetComponent<PersonBehaviour>();

                    arm1.gameObject.AddComponent<end>();

                    foreach (var body in person.Limbs)
                    {
                        body.BaseStrength += 2f;
                        body.Health *= 2.6f;
                        body.InitialHealth *= 2.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;

                        body.gameObject.AddComponent<NoSleep7>().spec = true;
                        body.gameObject.GetComponent<NoSleep7>().power = 1;
                    }


                }
            }
            );

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Android"),
    NameOverride = "The Artificial God" + " +HT",
    DescriptionOverride = "Turns the powers of the gifted against themselves" + "\n<b><i> <color=#ffC0cb>Z'othra</color> is no more.The Machine is now slowly marching through Void, looking like searching for something.Something it will never find.Artificial God just needs to find something... Or someone..." + "\n<color=green>[Tier 8] ",
    NameToOrderByOverride = "A8",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/ai.png"),

    AfterSpawn = (Instance) =>
    {
        var head = Instance.transform.Find("Head");
        var person = Instance.GetComponent<PersonBehaviour>();

        head.gameObject.AddComponent<reverse>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 2f;
            body.Health *= 52.6f;
            body.InitialHealth *= 52.6f;
            body.ShotDamageMultiplier = 0f;
           // body.CirculationBehaviour.AddLiquid(Liquid.GetLiquid(body.BloodLiquidType), 200f);
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 5f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.gameObject.AddComponent<ImmortalityBehaviour>();
            body.gameObject.AddComponent<NoSleep7>().power = 4;
            body.gameObject.GetComponent<NoSleep7>().time = 100f;
        }

        var skin = ModAPI.LoadTexture("textures/reverse.png");
        var f = ModAPI.LoadTexture("textures/fleshlayer3.png");
        var b = ModAPI.LoadTexture("textures/skeleton1.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, f, b);
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "SKULL-X1-6" + " +HT",
    DescriptionOverride = "Activate his arm to shoot" + "\n <color=orange>[Tier 4] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    NameToOrderByOverride = "A4",
    ThumbnailOverride = ModAPI.LoadSprite("textures/gun.png"),
    AfterSpawn = (Instance) =>
    {
    var person = Instance.GetComponent<PersonBehaviour>();

    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");


    arm1.gameObject.AddComponent<GunBeh>();
    Destroy(arm1.GetComponent<GripBehaviour>());
        

        
        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 4f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.gameObject.AddComponent<NoSleep7>().spec = true;

        }


    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Blast" + " +HT",
    DescriptionOverride = "Touch the object to mark it.Activate hand to explode all marked objects" + "\n <color=orange>[Tier 5] ",
    NameToOrderByOverride = "A5",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/deton.png"),

    AfterSpawn = (Instance) =>
    {
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var person = Instance.GetComponent<PersonBehaviour>();

        arm1.gameObject.AddComponent<Explo>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 2f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

            body.gameObject.AddComponent<NoSleep7>().spec = true;
            body.gameObject.GetComponent<NoSleep7>().power = 1;
        }


    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Buresu" + " +HT",
    DescriptionOverride = "Causes internal bleeding in nearby humans" + "\n<b><i> They can't suppress <color=#ffC0cb>it</color> forever" + "\n <color=orange>[Tier 5] ",
    NameToOrderByOverride = "A5",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/bbb.png"),

    AfterSpawn = (Instance) =>
    {

        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");

        head.gameObject.AddComponent<Aura5>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 1f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;




            body.gameObject.AddComponent<NoSleep7>().power = 1;
            body.gameObject.GetComponent<NoSleep7>().spec = true;
        }
        var skin = ModAPI.LoadTexture("textures/Ox.png");
        Instance.GetComponent<PersonBehaviour>().SetBloodColour(0,0,200);
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

    }
}
);
          

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Shell" + " +HT",
    DescriptionOverride = "I wonder what can be put in it " + "\n <color=#ffC0cb>[Tier ???] ",
    NameToOrderByOverride = "b1",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/shellprev.png"),

    AfterSpawn = (Instance) =>
    {
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");
        var middle = Instance.transform.Find("Body").Find("MiddleBody");

        arm1.gameObject.AddComponent<ShellPunch>();
        arm2.gameObject.AddComponent<ShellPunch>();
        head.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        middle.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        arm1.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        arm2.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        middle.gameObject.AddComponent<Core>();

        head.gameObject.AddComponent<ShellAwake>();

        head.gameObject.AddComponent<Shell>();

        // head.gameObject.AddComponent<Pulse>();
        head.gameObject.AddComponent<LazerEye>();
        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 2f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;

            
            body.Person.SetBloodColour(2,2,2);
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.BreakingThreshold = float.PositiveInfinity;
            body.ExplodeLiquidAmount = 9999f;
            
            body.FreezingTemperature = -999999f;
            body.DiscomfortingHeatTemperature = 999999f;

            

            body.gameObject.GetComponent<PhysicalBehaviour>().BurningProgressionMultiplier = 0f;
            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.BurningTemperatureThreshold = 99999f;
            body.gameObject.GetComponent<PhysicalBehaviour>().ReflectsLasers = true;


            body.gameObject.AddComponent<NoSleep7>().spec = true;
            
            body.gameObject.GetComponent<NoSleep7>().power = 3;
        }
        var skin = ModAPI.LoadTexture("textures/Lost.png");
        var flesh = ModAPI.LoadTexture("textures/lostFlesh.png");
        var S = ModAPI.LoadTexture("textures/lostskeleton.png");

        Instance.GetComponent<PersonBehaviour>().SetBloodColour(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetBruiseColor(0,0,0);
        Instance.GetComponent<PersonBehaviour>().SetSecondBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetThirdBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, S);

    }
}
);













            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Hayu'Ko" + " +HT",
    DescriptionOverride = "Gives humans a low tier powers" + "\n <color=red>[Tier 6]",
    CategoryOverride = ModAPI.FindCategory("HT"),
    NameToOrderByOverride = "A6",
    ThumbnailOverride = ModAPI.LoadSprite("textures/21.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");


        arm1.gameObject.AddComponent<PowerGive>();




        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 4f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.gameObject.AddComponent<NoSleep7>().spec = true;

        }
        var skin = ModAPI.LoadTexture("textures/Hayu.png");
        var flesh = ModAPI.LoadTexture("textures/gFlesh.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, null);

    }
}
);








            ModAPI.Register(
                          new Modification()
                          {
                              OriginalItem = ModAPI.FindSpawnable("Brick"),
                              NameOverride = "A piece of <color=#ffC0cb>Z'othra's</color> soul",
                              DescriptionOverride = "Allows some of the gifted to reach their full potential",
                              NameToOrderByOverride = "b1",
                              CategoryOverride = ModAPI.FindCategory("HT"),
                              ThumbnailOverride = ModAPI.LoadSprite("textures/singularity.png"),
                              AfterSpawn = (Instance) =>
                              {
                                  foreach (var c in Instance.GetComponents<Collider2D>())
                                  {
                                      GameObject.Destroy(c);
                                  }
                                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/singularity.png");
                                  Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                                  Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0.5f, 0.8f, 1f);
                                  Instance.AddComponent<CircleCollider2D>();
                                  Instance.AddComponent<soul>();
                              }
                          }


                      );
            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Brick"),
                 NameOverride = "Power Tank",
                 DescriptionOverride = "Can take away, store, and transfer the abilities of Gifted humans \nRight click to change mode",
                 NameToOrderByOverride = "b1",
                 CategoryOverride = ModAPI.FindCategory("HT"),
                 ThumbnailOverride = ModAPI.LoadSprite("textures/battery.png"),
                 AfterSpawn = (Instance) =>
                 {
                     foreach (var c in Instance.GetComponents<Collider2D>())
                     {
                         GameObject.Destroy(c);
                     }

                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/battery.png");
                     Instance.FixColliders();

                  


                    

                    var RukaGlow = new GameObject();
                     RukaGlow.transform.SetParent(Instance.transform);
                     RukaGlow.transform.localPosition = new Vector3(0f, 0f);

                     var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

                     RukaSprite.sprite = ModAPI.LoadSprite("textures/battery1.png");
                     RukaSprite.material = ModAPI.FindMaterial("VeryBright");
                     RukaSprite.color = new Color(1f, 0f, 0f, 0.2f);
                     RukaSprite.sortingLayerName = "Top";




                     RukaGlow.transform.localScale = new Vector3(1f, 1f);

                     var RukaGlow1 = new GameObject();

                     RukaGlow1.transform.SetParent(Instance.transform);

                     RukaGlow1.transform.localPosition = new Vector3(0f, 0f);

                     RukaGlow.transform.localRotation = Quaternion.identity;
                     RukaGlow1.transform.localRotation = Quaternion.identity;
                     var RukaSprite1 = RukaGlow1.AddComponent<SpriteRenderer>();

                     RukaSprite1.sprite = ModAPI.LoadSprite("textures/battery2.png");

                     RukaSprite1.material = ModAPI.FindMaterial("VeryBright");

                     RukaGlow1.transform.localScale = new Vector3(1f, 1f);
                     RukaSprite1.sortingLayerName = "Top";
                     RukaSprite1.color = new Color(0f, 0f, 0f, 0.2f);

                     Instance.AddComponent<BoxCollider2D>();
                     Instance.AddComponent<Gifts>();
                 }
             }


          );
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Brick"),
                NameOverride = "The Meishu",
                DescriptionOverride = "Gives people completely random abilities on contact",
                NameToOrderByOverride = "b1",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/lead.png"),
                AfterSpawn = (Instance) =>
                {
                    foreach (var c in Instance.GetComponents<Collider2D>())
                    {
                        GameObject.Destroy(c);
                    }

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/lead.png");
                    Instance.FixColliders();






                    var RukaGlow = new GameObject();
                    RukaGlow.transform.SetParent(Instance.transform);
                    RukaGlow.transform.localPosition = new Vector3(0f, 0f);

                    var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

                    RukaSprite.sprite = ModAPI.LoadSprite("textures/lead1.png");
                    RukaSprite.material = ModAPI.FindMaterial("VeryBright");
                    RukaSprite.color = new Color(1f, 0f, 0f, 0.2f);
                    RukaSprite.sortingLayerName = "Top";




                    RukaGlow.transform.localScale = new Vector3(1f, 1f);

                    

                    Instance.AddComponent<Meishu>();
                }
            }


         );

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Brick"),
                NameOverride = "LH Toxin",
                DescriptionOverride = "Specially designed to get rid of regenerative abilities.It can be applied to any sharp object",
                NameToOrderByOverride = "b1",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/toxin.png"),
                AfterSpawn = (Instance) =>
                {
                    foreach (var c in Instance.GetComponents<Collider2D>())
                    {
                        GameObject.Destroy(c);
                    }

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/toxin.png");
                    Instance.FixColliders();
                    Instance.AddComponent<toxin>();


                }
            }


         );

            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "The Sightless" + " +HT",
NameToOrderByOverride = "A7",
DescriptionOverride = "Causes transformation into a creature of the void by hitting with his hand. Activate hand to switch ability" + "\n<b><i><color=#5e5e5e>I got him out of the void, now we'll all be free, right?</i></b>" + "\n <color=purple>[Tier 7]",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/trait.png"),
AfterSpawn = (Instance) =>
{
var person = Instance.GetComponent<PersonBehaviour>();

    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    arm1.gameObject.AddComponent<voidtouch>();







    






    foreach (var body in person.Limbs)
{
       
        
body.BaseStrength += 2f;
body.Health *= 2.6f;
body.InitialHealth *= 2.6f;
body.ShotDamageMultiplier *= 0.2f;
body.BreakingThreshold += 10f;
body.RegenerationSpeed += 10f;
body.Vitality *= 3f;
body.Numbness *= 3f;
        body.ExplodeLiquidAmount = 9999f;

        body.FreezingTemperature = -999999f;
        body.DiscomfortingHeatTemperature = 999999f;
        body.PhysicalBehaviour.ReflectsLasers = true;
body.CirculationBehaviour.BloodFlow *= 4f;
body.IsLethalToBreak = false;
body.gameObject.AddComponent<NoSleep7>();
body.gameObject.GetComponent<NoSleep7>().power = 2;
}
var skin = ModAPI.LoadTexture("textures/Traitor.png");
    Instance.GetComponent<PersonBehaviour>().SetBruiseColor(0, 0, 0);
    Instance.GetComponent<PersonBehaviour>().SetSecondBruiseColor(0, 0, 0);
    Instance.GetComponent<PersonBehaviour>().SetThirdBruiseColor(0, 0, 0);
    Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

}
}
);












            //            ModAPI.Register(
            //new Modification()
            //{
            //OriginalItem = ModAPI.FindSpawnable("Brick"),
            //NameOverride = "Test",
            //DescriptionOverride = "Test",
            //NameToOrderByOverride = "b5",
            //CategoryOverride = ModAPI.FindCategory("HT"),
            //ThumbnailOverride = ModAPI.LoadSprite("textures/Bolt.png"),
            //AfterSpawn = (Instance) =>
            //{


            ////Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Bolt.png");
            //foreach (var c in Instance.GetComponents<Collider2D>())
            //{
            // GameObject.Destroy(c);
            //}
            //Instance.AddComponent<BoxCollider2D>();
            //    Instance.AddComponent<Explo>();

            //}
            //}


            //);
            //            ModAPI.Register(
            //new Modification()
            //{
            //OriginalItem = ModAPI.FindSpawnable("Human"),
            //NameOverride = "TestHuman" + " +HT",
            //DescriptionOverride = "Activate his arm to shoot" + "\n <color=orange>[Tier 4] ",
            //CategoryOverride = ModAPI.FindCategory("HT"),
            //NameToOrderByOverride = "A4",
            //ThumbnailOverride = ModAPI.LoadSprite("textures/gun.png"),
            //AfterSpawn = (Instance) =>
            //{
            //var person = Instance.GetComponent<PersonBehaviour>();







            //foreach (var body in person.Limbs)
            //{
            //body.BaseStrength += 4f;
            //body.Health *= 1.6f;
            //body.InitialHealth *= 1.6f;
            //body.ShotDamageMultiplier *= 0.6f;
            //body.BreakingThreshold += 10f;
            //body.RegenerationSpeed += 4f;
            //body.Vitality *= 3f;
            //body.ImpactPainMultiplier *= 0.2f;
            //body.Numbness *= 3f;
            //        body.IsLethalToBreak = false;
            //body.gameObject.AddComponent<NoSleep3>();
            //        body.gameObject.GetComponent<LimbBehaviour>().PhysicalBehaviour.ConductOverride = false;

            //    }


            //}
            //}
            //);


        }
        public static void OnLoad()
        {
            powersprites.rukanormal = ModAPI.LoadSprite("textures/rukaudar.png");
            powersprites.rukaupg = ModAPI.LoadSprite("textures/rukaudar1.png");

            powersprites.braslet = ModAPI.LoadSprite("textures/Braslet.png");
            powersprites.brasletupg = ModAPI.LoadSprite("textures/Braslet22.png");
            powersprites.braslet2 = ModAPI.LoadSprite("textures/Braslet2.png");

        powersprites.puncho = ModAPI.LoadSprite("textures/puncho3.png");
            powersprites.punchoupg = ModAPI.LoadSprite("textures/puncho.png");



            powersprites.beam = ModAPI.LoadSprite("textures/beam.png");
            powersprites.brasletz = ModAPI.LoadSprite("textures/Brasletzo.png");

            powersprites.mask1 = ModAPI.LoadSprite("textures/mask1.png");

            powersprites.halo = ModAPI.LoadSprite("textures/BrokenHalo.png");

            powersprites.eye1 = ModAPI.LoadSprite("textures/glazaprost1.png");
            powersprites.eye2 = ModAPI.LoadSprite("textures/Glaz3.png");

            powersprites.sing = ModAPI.LoadSprite("textures/singularity.png");
            powersprites.gun = ModAPI.LoadSprite("textures/pleaseleave.png");
            powersprites.pellet = ModAPI.LoadSprite("textures/pellet.png");
          powersprites.it = ModAPI.LoadTexture("textures/it.png");

            powersprites.Forgotten = ModAPI.LoadSprite("textures/forgottenone1.png");
            powersprites.braslet4 = ModAPI.LoadSprite("textures/Braslet44.png");
            powersprites.braslet5 = ModAPI.LoadSprite("textures/Braslet45.png");

            powersprites.voids = new Texture2D[]
            {
                ModAPI.LoadTexture("textures/void1.png"),
ModAPI.LoadTexture("textures/void2.png"),
ModAPI.LoadTexture("textures/void3.png"),
ModAPI.LoadTexture("textures/void4.png")
        };


                 




        }
    }
    public class powersprites
    {
        public static Sprite braslet;
        public static Sprite braslet2;
        public static Sprite brasletz;
        public static Sprite braslet4;
        public static Sprite braslet5;
        public static Sprite brasletupg;
        public static Sprite rukanormal;
        public static Sprite rukaupg;
        public static Sprite puncho;
        public static Sprite punchoupg;


        public static Texture2D it;
        public static Texture2D[] voids;


        public static Sprite halo;
        public static Sprite eye1;
        public static Sprite eye2;
        public static Sprite sing;


        public static Sprite gun;
        public static Sprite pellet;


        public static Sprite Forgotten;
        public static Sprite mask1;
        public static Sprite beam;

        public static Sprite spritename(string name)
        {
            switch (name)
            {
                case "braslet":

                    return braslet;
                case "braslet2":

                    return braslet2;

                case "brasletupg":

                    return brasletupg;
                case "rukanormal":

                    return rukanormal;
                case "rukaupg":

                    return rukaupg;
                case "puncho":

                    return puncho;
                case "punchoupg":
                    return punchoupg;
                case "braslet4":
                    return braslet4;

                case "brasletz":
                    return brasletz;

                default:
                    return null;
            }
            

        }







    }


    public static class powersm
    {
        public static void acid(GameObject victim)
        {
            victim.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.4f;
        }
        public static void gold(GameObject victim)
        {
            victim.gameObject.GetComponent<LimbBehaviour>().Frozen = true;
            victim.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.9f, 0f, 1f);
            victim.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
        }
        public static void crusher(GameObject victim)
        {
            victim.gameObject.GetComponent<Rigidbody2D>().velocity = victim.GetComponent<Rigidbody2D>().velocity * 4;
            victim.gameObject.GetComponent<LimbBehaviour>().BreakBone();
            victim.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
            victim.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
        }
        public static void champion(GameObject victim)
        {
            victim.gameObject.GetComponent<LimbBehaviour>().BreakBone();
            victim.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
            victim.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
            victim.gameObject.GetOrAddComponent<dest>();
        }
 
        
        public static void Healmode(GameObject victim)
        {
            var dr = victim.gameObject.GetComponent<LimbBehaviour>();
                dr.HealBone();
                dr.Health = dr.InitialHealth;
                dr.Numbness = 0f;
                dr.CirculationBehaviour.HealBleeding();
                dr.CirculationBehaviour.IsPump = dr.CirculationBehaviour.WasInitiallyPumping;
                dr.CirculationBehaviour.BloodFlow = 5f;
                if (dr.CirculationBehaviour.GetAmount(dr.GetOriginalBloodType()) <= 1f)
                {
                    dr.CirculationBehaviour.AddLiquid(dr.GetOriginalBloodType(), 1.4f);
                }
                dr.BruiseCount = 0;
                dr.CirculationBehaviour.GunshotWoundCount = 0;
                dr.CirculationBehaviour.StabWoundCount = 0;

                dr.Person.Consciousness = 1f;
                dr.Person.ShockLevel = 0f;
                dr.Person.PainLevel = 0f;
                dr.Person.OxygenLevel = 1f;
                dr.Person.AdrenalineLevel = 1f;
                dr.SkinMaterialHandler.RottenProgress = 0f;
                dr.SkinMaterialHandler.AcidProgress = 0f;
                dr.PhysicalBehaviour.BurnProgress = 0f;
        }
        public static void Flamemode(GameObject victim)
        {
            victim.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 20f;
            victim.gameObject.GetComponent<PhysicalBehaviour>().Ignite();
            victim.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 1f;
        }
        public static void killmode(GameObject victim)
        {
            victim.gameObject.GetComponent<LimbBehaviour>().Health = 0f;
        }



        public static void absorb(GameObject victim)
        {
            victim.GetComponent<LimbBehaviour>().Crush();
        }
    }

}
